program worms;

{ (c) Heiko Purnhagen  18.11.94 }

uses
  crt,graph;

const
  numworm = 30;
  wormtail = 10;
  fracv = 20;
  fracx = 20;
  border = 50*fracx;
  maxtv = 1*fracv*fracx;
  maxta = 5;
  maxtogo = 50;
  maxtogow = 20;
  cw = 20*fracx;
  dw = 5*fracx;
  maxwo = 100*fracx;
  cd = 20;

var
  graphdriver,graphmode : integer;
  sizex,sizey,maxc : integer;
  sizexs,sizeys,sizex2,sizey2 : integer;
  xt,yt : integer;
  xtv,ytv : integer;
  xta,yta : integer;
  xw,yw,xwo,ywo,xwv,ywv : array[1..numworm] of integer;
  xwda,ywda : array[0..numworm,0..wormtail-1] of integer;
  whead,wtail : integer;
  togo : integer;
  togow : array[1..numworm] of integer;
  t,c : integer;

procedure initwt;
var
  i,j : integer;
begin
  for i := 1 to numworm do
  begin
    xw[i] := sizex2;
    yw[i] := sizey2;
    for j := 0 to wormtail-1 do
    begin
      xwda[i,j] := xw[i] div fracx;
      ywda[i,j] := yw[i] div fracx;
    end;
    togow[i] := 0;
    xwo[i] := 0;
    ywo[i] := 0;
    xwv[i] := 0;
    ywv[i] := 0;
  end;
  xt := sizex2;
  yt := sizey2;
  togo := 0;
  t := 0;
  xtv := 0;
  ytv := 0;
  xta := 0;
  yta := 0;
  for j := 0 to wormtail-1 do
  begin
    xwda[0,j] := xt div fracx;
    ywda[0,j] := yt div fracx;
  end;
  whead := wormtail-1;
  wtail := 0;
end;

procedure incworm;
begin
  whead := wtail;
  wtail := (wtail+1) mod wormtail;
end;

procedure movet;
begin
  xtv := xtv + xta;
  ytv := ytv + yta;
  if xtv > maxtv then
  begin
    xtv := maxtv;
    xta := 0;
  end;
  if xtv < -maxtv then
  begin
    xtv := -maxtv;
    xta := 0;
  end;
  if ytv > maxtv then
  begin
    ytv := maxtv;
    yta := 0;
  end;
  if ytv < -maxtv then
  begin
    ytv := -maxtv;
    yta := 0;
  end;
  xt := xt + xtv div fracv;
  yt := yt + ytv div fracv;
  if xt < border then
    xta := maxta;
  if xt > sizexs-border then
    xta := -maxta;
  if yt < border then
    yta := maxta;
  if yt > sizeys-border then
    yta := -maxta;
  xwda[0,whead] := xt div fracx;
  ywda[0,whead] := yt div fracx;
  if togo <= 0 then
  begin
    xta := -maxta+random(2*maxta+1);
    yta := -maxta+random(2*maxta+1);
    togo := maxtogo;
  end
  else
    dec(togo);
end;

procedure calcw;
var
  i : integer;
  xa,ya : integer;
begin
  for i := 1 to numworm do
  begin
    xa := (xt-xw[i]+xwo[i]) div cw - xwv[i] div dw;
    ya := (yt-yw[i]+ywo[i]) div cw - ywv[i] div dw;
    xwv[i] := xwv[i] + xa;
    ywv[i] := ywv[i] + ya;
    xw[i] := xw[i] + xwv[i] div fracv;
    yw[i] := yw[i] + ywv[i] div fracv;
    xwda[i,whead] := xw[i] div fracx;
    ywda[i,whead] := yw[i] div fracx;
    if togow[i] <= 0 then
    begin
      xwo[i] := -maxwo+random(2*maxwo+1);
      ywo[i] := -maxwo+random(2*maxwo+1);
      togow[i] := random(maxtogow);
    end
    else
      dec(togow[i]);
  end;
end;

procedure drawwt;
var
  i : integer;
begin
  inc(t);
  c := 1 + (t div cd) mod maxc;
  putpixel (xwda[0,wtail],ywda[0,wtail],0);
  for i := 1 to numworm do
    putpixel (xwda[i,wtail],ywda[i,wtail],0);
  putpixel (xwda[0,whead],ywda[0,whead],maxc);
  for i := 1 to numworm do
    putpixel (xwda[i,whead],ywda[i,whead],1+(i mod 7));
end;


begin
  graphdriver := 0;
  graphmode := 0;
  initgraph (graphdriver,graphmode,'\tp\bgi');
  if graphresult <> 0 then
  begin
    writeln ('no graphics');
    exit;
  end;
  sizex := getmaxx+1;
  sizey := getmaxy+1;
  sizexs := sizex*fracx;
  sizeys := sizey*fracx;
  sizex2 := sizexs div 2;
  sizey2 := sizeys div 2;
  maxc := getmaxcolor;

  randomize;
  initwt;
  repeat
    incworm;
    movet;
    calcw;
    drawwt;
  until keypressed;

  restorecrtmode;
  closegraph;
end.
