/* xgraph.h */
/* A Turbo Pascal 6.0 GRAPH.TPU like interface to X11. */
/* (c) Heiko Purnhagen <purnhage@tnt.uni-hannover.de> */
/* $Id: xgraph.h,v 1.3 1998/12/30 12:50:08 purnhage Exp $ */
/* HP 980908 */

#ifndef _xgraph_h_
#define _xgraph_h_

#ifdef __cplusplus
extern "C" {
#endif

#define NCOLORS 16

#define Black 0
#define Blue 1
#define Green 2
#define Cyan 3
#define Red 4
#define Magenta 5
#define Brown 6
#define LightGray 7
#define DarkGray 8
#define LightBlue 9
#define LightGreen 10
#define LightCyan 11
#define LightRed 12
#define LightMagenta 13
#define Yellow 14
#define White 15


void InitGraph (int *GraphDriver, int *GraphMode, char *PathToDriver);
int GraphResult (void);
void RestoreCrtMode (void);
void CloseGraph (void);

int GetMaxColor (void);
int GetMaxX (void);
int GetMaxY (void);

void SetColor(int Color);
void Line (int x1, int y1, int x2, int  y2);
void PutPixel (int x, int y, int Pixel);

#ifdef __cplusplus
}
#endif

#endif  /* #ifndef _xgraph_h_ */

/* end of xgraph.h */
