/***

xworms (somewhat similar to xlock -mode swarm)

$Id: xworms.c,v 1.3 1998/12/30 18:35:24 purnhage Exp $

(c) Heiko Purnhagen 1998
e-mail: purnhage@tnt.uni-hannover.de
WWW:    http://www.tnt.uni-hannover.de/~purnhage/

All usual disclaimers apply!

This program may be copied according to the GNU General Public Licence.
See file COPYING for further details.

HP 980908 981220

usage: xworms
       ... and quit with ^C ;-)

***/


#include <stdio.h>
#include <stdlib.h>

#include "xgraph.h"


/* some Turbo Pascal stuff */

int KeyPressed (void)
{
  return 0;
}

#define RND_MAX 0x7fffffff

/* random1() */
/* Generate random long (uniform distribution 0..RND_MAX). */

long random1 (void)
{
  static long randx = 1;
  
  randx = (randx * 1103515245) + 12345;
  return (randx & RND_MAX);
}

void _randomize (void)
{
}

int _randint (int max)
{
 return random1() % max;  
}


/* code based on "p2c worms.pas" */

/* #define numworm         50 */
/* #define wormtail        10 */
/* #define fracv           20 */
/* #define fracx           20 */
#define numworm         100
#define wormtail        100
#define fracv           100
#define fracx           50

#define border          (fracx * 50)

/* #define maxtv           (fracv * fracx) */
/* #define maxta           5 */
/* #define maxtogo         50 */
/* #define maxtogow        20 */
#define maxtv           (fracv * fracx / 2)
#define maxta           5
#define maxtogo         50
#define maxtogow        50

#define cw              (fracx * 20)
#define dw              (fracx * 5)
/* #define maxwo           (fracx * 100) */
#define maxwo           (fracx * 400)


int graphdriver, graphmode, sizex, sizey, maxc, sizexs, sizeys,
  sizex2, sizey2, xt, yt, xtv, ytv, xta, yta;
int xw[numworm], yw[numworm], xwo[numworm], ywo[numworm],
  xwv[numworm], ywv[numworm];
int xwda[numworm + 1][wormtail], ywda[numworm + 1][wormtail];
int whead, wtail, togo;
int togow[numworm];


void initwt()
{
  short i, j;

  for (i = 1; i <= numworm; i++) {
    xw[i - 1] = sizex2;
    yw[i - 1] = sizey2;
    for (j = 0; j < wormtail; j++) {
      xwda[i][j] = xw[i - 1] / fracx;
      ywda[i][j] = yw[i - 1] / fracx;
    }
    togow[i - 1] = 0;
    xwo[i - 1] = 0;
    ywo[i - 1] = 0;
    xwv[i - 1] = 0;
    ywv[i - 1] = 0;
  }
  xt = sizex2;
  yt = sizey2;
  togo = 0;
  xtv = 0;
  ytv = 0;
  xta = 0;
  yta = 0;
  for (j = 0; j < wormtail; j++) {
    xwda[0][j] = xt / fracx;
    ywda[0][j] = yt / fracx;
  }
  whead = wormtail - 1;
  wtail = 0;
}


void incworm()
{
  whead = wtail;
  wtail = (wtail + 1) % wormtail;
}


void movet()
{
  xtv += xta;
  ytv += yta;
  if (xtv > maxtv) {
    xtv = maxtv;
    xta = 0;
  }
  if (xtv < -maxtv) {
    xtv = -maxtv;
    xta = 0;
  }
  if (ytv > maxtv) {
    ytv = maxtv;
    yta = 0;
  }
  if (ytv < -maxtv) {
    ytv = -maxtv;
    yta = 0;
  }
  xt += xtv / fracv;
  yt += ytv / fracv;
  if (xt < border)
    xta = maxta;
  if (xt > sizexs - border)
    xta = -maxta;
  if (yt < border)
    yta = maxta;
  if (yt > sizeys - border)
    yta = -maxta;
  xwda[0][whead] = xt / fracx;
  ywda[0][whead] = yt / fracx;
  if (togo > 0) {
    togo--;
    return;
  }
  xta = _randint(maxta * 2L + 1) - maxta;
  yta = _randint(maxta * 2L + 1) - maxta;
  togo = maxtogo;
}


void calcw()
{
  short i, xa, ya;

  for (i = 0; i < numworm; i++) {
    xa = (xt - xw[i] + xwo[i]) / cw - xwv[i] / dw;
    ya = (yt - yw[i] + ywo[i]) / cw - ywv[i] / dw;
    xwv[i] += xa;
    ywv[i] += ya;
    xw[i] += xwv[i] / fracv;
    yw[i] += ywv[i] / fracv;
    xwda[i + 1][whead] = xw[i] / fracx;
    ywda[i + 1][whead] = yw[i] / fracx;
    if (togow[i] <= 0) {
      xwo[i] = _randint(maxwo * 2L + 1) - maxwo;
      ywo[i] = _randint(maxwo * 2L + 1) - maxwo;
      togow[i] = _randint((long)maxtogow);
    } else
      togow[i]--;
  }
}


void drawwt()
{
  short i;

  PutPixel(xwda[0][wtail], ywda[0][wtail], 0);
  for (i = 1; i <= numworm; i++)
    PutPixel(xwda[i][wtail], ywda[i][wtail], 0);
  PutPixel(xwda[0][whead], ywda[0][whead], maxc);
  for (i = 1; i <= numworm; i++)
    PutPixel(xwda[i][whead], ywda[i][whead], 1+i%(maxc-2));
}


int main (int argc, char *argv[])
{
  graphdriver = 0;
  graphmode = 0;
  InitGraph(&graphdriver, &graphmode, "\\tp6\\bgi");
  if (GraphResult() != 0) {
    fprintf(stderr,"no graphics\n");
    exit(-1);
  }
  sizex = GetMaxX() + 1;
  sizey = GetMaxY() + 1;
  sizexs = sizex * fracx;
  sizeys = sizey * fracx;
  sizex2 = sizexs / 2;
  sizey2 = sizeys / 2;
  maxc = GetMaxColor();

  _randomize();
  initwt();
  do {
    incworm();
    movet();
    calcw();
    drawwt();
  } while (!KeyPressed());

  RestoreCrtMode();
  CloseGraph();
  exit(0);
}


/* end of worms.c */
